package com.supwisdom.institute.backend.common.core.transmit.config;

import org.springframework.boot.autoconfigure.condition.ConditionalOnClass;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import com.supwisdom.institute.backend.common.core.transmit.feign.SimpleUserTransmitRequestInterceptor;

import feign.Feign;
import lombok.extern.slf4j.Slf4j;

@Configuration
@ConditionalOnClass(Feign.class)
@Slf4j
public class SimpleUserTransmitFeignConfiguration {
  
  @Bean
  public SimpleUserTransmitRequestInterceptor simpleUserTransmitRequestInterceptor() {
    log.debug("-----SimpleUserTransmitRequestInterceptor");
    return new SimpleUserTransmitRequestInterceptor();
  }
  
}
